unit Psapi;

{$IMPORTEDDATA OFF}

interface

uses Windows;

type
  PHMODULE = ^HMODULE;

  TProcessMemoryCounters = packed record
    cb: DWORD;
    PageFaultCount: DWORD;
    PeakWorkingSetSize: DWORD;
    WorkingSetSize: DWORD;
    QuotaPeakPagedPoolUsage: DWORD;
    QuotaPagedPoolUsage: DWORD;
    QuotaPeakNonPagedPoolUsage: DWORD;
    QuotaNonPagedPoolUsage: DWORD;
    PagefileUsage: DWORD;
    PeakPagefileUsage: DWORD;
  end;
  PProcessMemoryCounters = ^TProcessMemoryCounters;

  TModuleInfo = packed record
    lpBaseOfDll: Pointer;
    SizeOfImage: DWORD;
    EntryPoint: Pointer;
  end;
  PModuleInfo = ^TModuleInfo;

var
  EnumProcesses: function (pProcessIds: PDWORD; cb: DWORD;
    pBytesReturned: PDWORD): BOOL; stdcall;
  EnumProcessModules: function (hProcess: THandle; lphModule: PHMODULE;
    cb: DWORD; lpcbNeeded: LPDWORD): BOOL; stdcall;
  GetMappedFileName: function (hProcess: THandle; lpv: Pointer;
    lpFileName: LPTSTR; nSize: DWORD): DWORD; stdcall;
  GetModuleBaseName: function (hProcess: THandle; hModule: HMODULE;
    lpBaseName: LPTSTR; nSize: DWORD): DWORD; stdcall;
  GetModuleFileNameEx: function (hProcess: THandle; hModule: HMODULE;
    lpFileName: LPTSTR; nSize: DWORD): DWORD; stdcall;
  GetModuleInformation: function (hProcess: THandle; hModule: HMODULE;
    lpmodinfo: PModuleInfo; cb: DWORD): BOOL; stdcall;
  GetProcessMemoryInfo: function (hProcess: THandle;
    ppsmemCounters: PProcessMemoryCounters; cb: DWORD): BOOL; stdcall;
  GetProcessImageFileName: function (hProcess: Thandle;
    lpImageFileName: LPTSTR; nSize:DWORD): DWORD; stdcall;

implementation

uses NDllLoader;

var
  h: HMODULE;
begin
  h := LoadDLL('psapi.dll');
  if h = 0 then
    Exit;
  EnumProcesses := GetProcAddress(h, 'EnumProcesses');
  EnumProcessModules := GetProcAddress(h, 'EnumProcessModules');
  GetMappedFileName := GetProcAddress(h, 'GetMappedFileNameA');
  GetModuleBaseName := GetProcAddress(h, 'GetModuleBaseNameA');
  GetModuleFileNameEx := GetProcAddress(h, 'GetModuleFileNameExA');
  GetModuleInformation := GetProcAddress(h, 'GetModuleInformation');
  GetProcessMemoryInfo := GetProcAddress(h, 'GetProcessMemoryInfo');
  // XP or later
  GetProcessImageFileName := GetProcAddress(h, 'GetProcessImageFileNameA');
end.
